
//=======================================================
//  This code is generated by Terasic System Builder
//=======================================================

module PCIe_Fundamental(

	//////////// CLOCK //////////
	GCLKIN,
	GCLKOUT_FPGA,
	OSC_50_BANK2,
	OSC_50_BANK3,
	OSC_50_BANK4,
	OSC_50_BANK5,
	OSC_50_BANK6,
	OSC_50_BANK7,
	PLL_CLKIN_p,

	//////////// External PLL //////////
	MAX_I2C_SCLK,
	MAX_I2C_SDAT,

	//////////// LED x 8 //////////
	LED,

	//////////// BUTTON x 4, EXT_IO and CPU_RESET_n //////////
	BUTTON,
	CPU_RESET_n,
	EXT_IO,

	//////////// SLIDE SWITCH x 4 //////////
	SLIDE_SW,

	//////////// SEG7 //////////
	SEG0_D,
	SEG0_DP,
	SEG1_D,
	SEG1_DP,

	//////////// Fan //////////
	FAN_CTRL,

	//////////// PCIe x 8 //////////
	PCIE_PREST_n,
	PCIE_REFCLK_p,
	PCIE_RX_p,
	PCIE_SMBCLK,
	PCIE_SMBDAT,
	PCIE_TX_p,
	PCIE_WAKE_n 
);

//=======================================================
//  PARAMETER declarations
//=======================================================


//=======================================================
//  PORT declarations
//=======================================================

//////////// CLOCK //////////
input 		          		GCLKIN;
output		          		GCLKOUT_FPGA;
input 		          		OSC_50_BANK2;
input 		          		OSC_50_BANK3;
input 		          		OSC_50_BANK4;
input 		          		OSC_50_BANK5;
input 		          		OSC_50_BANK6;
input 		          		OSC_50_BANK7;
input 		          		PLL_CLKIN_p;

//////////// External PLL //////////
output		          		MAX_I2C_SCLK;
inout 		          		MAX_I2C_SDAT;

//////////// LED x 8 //////////
output		     [7:0]		LED;

//////////// BUTTON x 4, EXT_IO and CPU_RESET_n //////////
input 		     [3:0]		BUTTON;
input 		          		CPU_RESET_n;
inout 		          		EXT_IO;

//////////// SLIDE SWITCH x 4 //////////
input 		     [3:0]		SLIDE_SW;

//////////// SEG7 //////////
output		     [6:0]		SEG0_D;
output		          		SEG0_DP;
output		     [6:0]		SEG1_D;
output		          		SEG1_DP;

//////////// Fan //////////
output		          		FAN_CTRL;

//////////// PCIe x 8 //////////
input 		          		PCIE_PREST_n;
input 		          		PCIE_REFCLK_p;
input 		     [3:0]		PCIE_RX_p;
input 		          		PCIE_SMBCLK;
inout 		          		PCIE_SMBDAT;
output		     [3:0]		PCIE_TX_p;
output		          		PCIE_WAKE_n;


//=======================================================
//  REG/WIRE declarations
//=======================================================




//=======================================================
//  External PLL Configuration ==========================
//=======================================================

//  Signal declarations
wire [ 3: 0] clk1_set_wr, clk2_set_wr, clk3_set_wr;
wire         rstn;
wire         conf_ready;
wire         counter_max;
wire  [7:0]  counter_inc;
reg   [7:0]  auto_set_counter;
reg          conf_wr;

//  Structural coding
assign clk1_set_wr = 4'd0; //Unchange MHZ
assign clk2_set_wr = 4'd0; //Unchange MHZ
assign clk3_set_wr = 4'd4; //100 MHZ

assign rstn = CPU_RESET_n;
assign counter_max = &auto_set_counter;
assign counter_inc = auto_set_counter + 1'b1;

always @(posedge OSC_50_BANK2 or negedge rstn)
	if(!rstn)
	begin
		auto_set_counter <= 0;
		conf_wr <= 0;
	end 
	else if (counter_max)
		conf_wr <= 1;
	else
		auto_set_counter <= counter_inc;


ext_pll_ctrl ext_pll_ctrl_Inst(
	.osc_50(OSC_50_BANK2), //50MHZ
	.rstn(rstn),

	// device 1 (HSMA_REFCLK)
	.clk1_set_wr(clk1_set_wr),
	.clk1_set_rd(),

	// device 2 (HSMB_REFCLK)
	.clk2_set_wr(clk2_set_wr),
	.clk2_set_rd(),

	// device 3 (PLL_CLKIN/SATA_REFCLK)
	.clk3_set_wr(clk3_set_wr),
	.clk3_set_rd(),

	// setting trigger
	.conf_wr(conf_wr), // 1T 50MHz 
	.conf_rd(), // 1T 50MHz

	// status 
	.conf_ready(conf_ready),

	// 2-wire interface 
	.max_sclk(MAX_I2C_SCLK),
	.max_sdat(MAX_I2C_SDAT)

);


//=======================================================
//  Structural coding
//=======================================================
wire clk50;
wire clk_125m;
wire pll_lock;
wire reset_n;

wire	[16 : 0]	reconfig_fromgxb;
wire	[3 : 0]	reconfig_togxb;
wire 				busy;

assign reset_n = CPU_RESET_n;
assign 	PCIE_WAKE_n = 1'b1;
	

	
pll p0(
	.inclk0(OSC_50_BANK2),
	.c0(clk50),
	.c1(clk_125m),
	.locked(pll_lock)
);
	
altgx_reconfig p1 (
	.reconfig_clk (clk50),
	.reconfig_fromgxb (reconfig_fromgxb),
	.busy (busy),
	.reconfig_togxb (reconfig_togxb)
);
	
    q_sys u0 (
        .clkin_100_clk                                      (PLL_CLKIN_p),                                      //                          clkin_50.clk
        .clkin_100_clk_in_reset_reset_n                     (reset_n),                     //             clkin_50_clk_in_reset.reset_n
        .pio_led_external_connection_export                (pio_led),                //       pio_led_external_connection.export
        .pio_key_external_connection_export                (pio_button),                 //       pio_key_external_connection.export
          
		  .pcie_hard_ip_0_refclk_export                      (PCIE_REFCLK_p),                      //             pcie_hard_ip_0_refclk.export
        .pcie_hard_ip_0_pcie_rstn_export                   (PCIE_PREST_n),                   //          pcie_hard_ip_0_pcie_rstn.export
		  .pcie_hard_ip_0_pipe_ext_powerdown_ext 				  (~PCIE_PREST_n), 
		  .pcie_hard_ip_0_reconfig_busy_busy_altgxb_reconfig (busy), //      pcie_hard_ip_0_reconfig_busy.busy_altgxb_reconfig
        .pcie_hard_ip_0_rx_in_rx_datain_0                  (PCIE_RX_p[0]),                  //              pcie_hard_ip_0_rx_in.rx_datain_0
        .pcie_hard_ip_0_rx_in_rx_datain_1                  (PCIE_RX_p[1]),                  //                                  .rx_datain_1
        .pcie_hard_ip_0_rx_in_rx_datain_2                  (PCIE_RX_p[2]),                  //                                  .rx_datain_2
        .pcie_hard_ip_0_rx_in_rx_datain_3                  (PCIE_RX_p[3]),                  //                                  .rx_datain_3
        .pcie_hard_ip_0_tx_out_tx_dataout_0                (PCIE_TX_p[0]),                //             pcie_hard_ip_0_tx_out.tx_dataout_0
        .pcie_hard_ip_0_tx_out_tx_dataout_1                (PCIE_TX_p[1]),                //                                  .tx_dataout_1
        .pcie_hard_ip_0_tx_out_tx_dataout_2                (PCIE_TX_p[2]),                //                                  .tx_dataout_2
        .pcie_hard_ip_0_tx_out_tx_dataout_3                (PCIE_TX_p[3]),                //                                  .tx_dataout_3
        .pcie_hard_ip_0_reconfig_togxb_data                (reconfig_togxb),                //     pcie_hard_ip_0_reconfig_togxb.data
        .pcie_hard_ip_0_reconfig_fromgxb_0_data            (reconfig_fromgxb),            // pcie_hard_ip_0_reconfig_fromgxb_0.data
        .pcie_hard_ip_0_fixedclk_clk                       (clk_125m)                        //           pcie_hard_ip_0_fixedclk.clk
    );
	 

wire [7:0]	 pio_led;
wire [3:0]	 pio_button;
assign LED = ~pio_led; // led low-active
assign pio_button = ~BUTTON; // button low-active
assign FAN_CTRL = 1'b1;


endmodule
